#include "Users.h"

Users::Users(/* args */)
{
    this->_userdb.insert(user_account{.uid = 1, .first_name = "John", .last_name = "Doe", .rfid_uid = "8C 75 6C 17", .user_pin = "2424"});
    this->_userdb.insert(user_account{.uid = 2, .first_name = "Max", .last_name = "Mustermann and Sons", .rfid_uid = "D3 4E 03 0B", .user_pin = "1212"});
}

Users::~Users()
{
}
bool Users::checkPin(String pin_code, std::vector<Users::User> *logon_users)
{
    std::copy_if(this->_userdb.begin(), this->_userdb.end(), inserter(*logon_users, logon_users->end()), [=](user_account user)
                 { return pin_code == user.user_pin; });
    return (logon_users->size() > 0);
}

bool Users::checkRfid(String rfid_code, std::vector<Users::User> *logon_users)
{
    std::copy_if(this->_userdb.begin(), this->_userdb.end(), inserter(*logon_users, logon_users->end()), [=](user_account user)
                 { return rfid_code == user.rfid_uid; });
    return (logon_users->size() > 0);
}

unsigned long Users::addUser(String first_name, String last_name, String rifd_uid, String user_pin)
{
    unsigned long new_id = this->_userdb.rbegin()->uid + 1;
    this->_userdb.insert(user_account{.uid = new_id, .first_name = first_name, .last_name = last_name, .rfid_uid = rifd_uid, .user_pin = user_pin});
    return new_id;
}

bool Users::delUser(unsigned long id)
{
    return this->_userdb.erase(user_account{.uid = id})>0;
}

bool Users::updateUser(unsigned long id, ATTRIBUTES attr, String value)
{
    auto  modify = this->_userdb.find(user_account{.uid = id});
    switch (attr)
    {
    case FIRST_NAME:
        modify->first_name = value;
        break;
    case LAST_NAME:
        modify->last_name = value;
        break;
    case RFID_UID:
        modify->rfid_uid = value;
        break;
    case USER_PIN:
        modify->user_pin = value;
        break;

    default:
        break;
    }
    return false;
}

String Users::toString(User *user)
{
    return "UID: " + String(user->uid) + " Name: " + user->first_name + " " + user->last_name;
}