import {
  BrowserRouter as Router,
  Switch,
  Route,
} from "react-router-dom";
import { ThemeProvider } from "styled-components";
import {CreateUserWidget, RecentActivityWidget, SystemStatusWidget} from './components'
import {AccountManager, AdminUI, Logs, System} from './views'
import theme from './theme';
function App() {
  return (
    <Router>
      <ThemeProvider theme={theme}>
      <AdminUI>
        <Switch>
          <Route path="/" exact>
            <CreateUserWidget />
            <RecentActivityWidget />
            <SystemStatusWidget />
          </Route>
          <Route path="/accounts">
            <AccountManager/>
          </Route>
          <Route path="/log">
            <Logs/>
          </Route>
          <Route path="/system">
            <System/>
          </Route>
        </Switch>
      </AdminUI>
      </ThemeProvider>
    </Router>
  );
}

export default App;
